%% See README.writers
%% Copyright 2014 YOUR-NAME
%% Copyright 2014 Gerald Turner <gturner@unzane.com>
%% Copyright 2014 Kees Cook <kees@debian.org>
%% Copyright 2014 Stefano Rivera <stefanor@debian.org>
%% License: CC-BY-SA-3.0
%%
\section{Network}

% Perhaps start off by describing that we went with cheap and easy and PSU's
% network turned out to be good enough.  We didn't do any fancy QoS,
% transparent proxying, debian mirrors, etc.

\subsection{General}

Portland State University provided their existing wired and wireless network,
that was shared across the entire campus, including housing.  No additional
circuits were installed for the conference.

We were concerned about potential issues (as has happened so many times
at DebConf before), so we had spare equipment and plans in case problems would
show. Fortunately it worked and we didn't need to scramble to get fixes into
place.

\subsection{Uplink}

The network was IPv4-only.  A casual speed test revealed 638\,Mbps download
and 268\,Mbps upload speeds. The IPs provided via DHCP were public IP addresses
(i.e.\ non-RFC1918) but were in-bound filtered from the Internet. The only
filtering we noticed in the out-bound direction was port 25 being blocked.

\subsection{Wired Network}

Each room at the Smith Memorial Student Union building had at least one 100\,Mbps
port connecting it to Portland State University's network.  Ten 48-port switches
were brought to the conference (mostly Cisco Catalyst 3560s), and installed in
the Data Center room and the two hacklabs.  No advanced features of these
switches were used.  Additional cabling was installed between the talk
rooms, including the Ballroom, and the Data Center.  This cabling was used to
isolate the Video Team's network with 1\,Gbps ports on an internal network.

PSU's wired network provided DHCPv4 leases with public IP addresses.  We were
told that inbound traffic was firewalled.  This caused some difficulty
for video streaming, our webm repeater (cubemap) connects to the source,
rather than having the source connect to it.  We worked around the
problem, by hosting a repeater on a server in the Portland State
University Computer Science Department's network that was not
firewalled.

\subsection{Wireless Network}

Portland State University had a policy that we couldn't run our own wireless
network.  The University's wireless network had a captive portal that required
registration via email every 24~hours.  The same wireless network was available
throughout the Smith Memorial Student Union building, the housing, and the
surrounding parks.

To make things easier, Kees set up a special email address that people could
use on the captive portal registration, which automated responding to the
authentication email.  This meant, for each attendee, the process of daily
authentication was reduced to filling out the form (30~seconds), rather
than also having to wait for an email to reply to (10~minutes). This also solved
the problem where some ISPs were not accepting the emails that PSU was
generating.

Unlike the wired connections that PSU provided, the wireless network provided
DHCPv4 leases with private IP addresses.

As a backup plan, in case PSU's wireless wasn't robust enough, we had brought
twenty-four Motorola/Symbol Access Point radio modules and a single controller.
Luckily the wireless network was sufficient.  The equipment would have made use
of the PoE switches.

\subsection{Local Servers and Network Configuration}

Unlike past DebConfs, the only servers that were set up were for use by the
Video Team.  The local team provided a 1U chassis with about an 8\,year old Xeon
and 8\,GB RAM, as well as a new desktop PC with Intel i7-4790K and 32\,GB RAM
(which took many hours to solve UEFI boot issues!).

The 1U server was used for storage and as a gateway for the video
network.  It had two 1\,TiB SATA drives configured in a RAID1
set, and received regular backups of all recorded video via rsync.
This storage was served via NFSv3 to the i7 desktop.
%
The storage server ran a DHCP server for the private Video Team network,
and NATed outgoing traffic.  It also run a CUPS server, for the printer
in the NOC that was on the Video Team network.  The webm video
streaming required a cubemap server for outside cubemap master relay to
connect to, this ran on the storage server, too.
%
The i7 desktop PC ran three VLC instances, encoding webm video
streams in real time.

Both machines were used for after hours, preliminary encoding of
recorded video.
%
The storage server proved to be reliable, despite its age.  The i7
desktop occasionally powered off, uncommanded.  This was never debugged,
but didn't cause too much trouble, either.


\subsection{Talk Rooms}

The video team had a dedicated network, custom cables were run from the NOC
to each talk room and connected to an 8-port Gigabit Ethernet switch.

\subsection{Hacklabs}
\figwrap{O}{0.35}{images/photos/hacklab_infrastructure}{Hacklab infrastructure}{joeyh}
When arranging the layout of the hacklabs, access to power was the primary
concern.  Most people used the wireless network and for the few
using cabled access, it was easier to route network cable to the
table rather than power.

Rather than arrange tables in the middle of the room, we created
“peninsulas” of two tables sticking out from the walls where power outlets
were present and then ran power strips to the middle.  Most tables had
North American outlet power strips, but for one table in each lab we
provided a more universal power strip that supported many standards.
The Europeans tended to use those tables and appreciated not needing to
use adapters.  One thing that might have been nice is to go to a computer
recycling center and get a bunch of laptop power cables, the “mickey mouse”
to wall outlet part of the cable to give to attendees that needed it. We'll
pursue this idea at future conferences.

At the head of each set of tables (by the wall) we placed a network switch,
and provided a few short cables for people to use.

For the third-floor hacklab, there was a single port turned on.  We plugged
an 8-port Gigabit Ethernet switch into that, and connected the other switches.
Most of the power in the room was on the opposite wall, so we ran a custom
length cable above the drop ceiling to the other side, and connected the
switches on that side in a star pattern.

For the second floor hacklab, the promised port was not turned
on until a few days into the conference.
People therefore mostly used wireless. A local student set up a laptop
to provide wired access to those without wireless cards by bridging to a
static wireless connection. After the port was turned on, cable was run,
and several tables were connected to the wired network.

One interesting thing to note was that contacting the Campus networking team
was usually pretty difficult and it made things easier that a couple of local
students happened to know people in that organization and knew what IRC
channel they used.  That sped up communication greatly.

\subsection{Dorms}

The dorms had both wireless and wired ports and attendees had no
problems using them.  This was very nice as it made
communication/coordination easy, particularly on IRC.

\subsection{Incidents}

For the most part, everything ran smoothly with the PSU networks. There
were some intermittent problems with wireless connectivity, but they
appeared to be isolated cases involving either a specific WAP or a specific
client device. These kinds of glitches tended to be solved by either physically
moving around, or changing the client device's wireless MAC.

There was an outage for most of one day on the wired network that
degraded the effective QoS and caused the Video Team to be unable to
copy raw files out to the remote video storage server (outside PSU's
network). This was ultimately debugged to being clearly a network path
issue inside PSU's network since the outbound path was nearly identical
to a remote server from wireless and from wired. Wired had several
additional hops before it reached the PSU border gateways. PSU sent
staff to our NOC in an attempt to debug it further. Later in the day,
a problem was discovered with the “building firewall”, and fixed, at
which point Video Team network performance returned to what was expected.

A DHCP outage on the Video Team network was eventually determined to be
caused by the Video Team's core switch dropping packets.  It was a
consumer grade store-and-forward gigabit switch, and we swapped it out
for a Cisco Catalyst 3560G that had been kept aside.  After that, there
were no further incidents in the internal network.
%
\Person{Gerald Turner, Kees Cook, Matt Taggart, Stefano Rivera}



%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "dc14-report.en"
%%% End: 
